package experiment.event.capability;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Mar 11, 2010
 *
 * A Data object contains the data for a single cabability update
 */
public class Directive {

    private String key;
    private String data;

    /**
     * Default constructor. It doesn't allow null values as every directive should actually hold a direction.
     *
     * @param key the attribute of the data change
     * @param data the new value
     */
    public Directive(String key, String data) {

        if (key == null || data == null){
            return;
        }

        this.key = key;
        this.data = data;
    }

    /**
     * @return the capability name
     */
    public String getKey() {
        return key;
    }

    /**
     * @return Capability's new value
     */
    public String getData() {
        return data;
    }
}
