package experiment.event.capability;

import experiment.event.Event;
import experiment.ExperimentState;

import java.util.LinkedList;

import walker.exceptions.badSyntaxException;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Mar 26, 2010
 *
 * Conttains abstract methods and a directiveList. It provides a common way for manipulating ValueEvents.
 */
public abstract class ValueEvent extends Event {

    protected LinkedList<Directive> directiveList = new LinkedList<Directive>();

    /**
     * Add a new Direcrive object to this ValueEvent
     * @param d contains a single capability change
     */
    public void addData(Directive d){
        directiveList.add(d);
    }

    /**
     * Applies this event to the experiment.
     *
     * @param state the experiment state where this event belong to.
     * @return true if event was successfully applied.
     * @throws walker.exceptions.badSyntaxException in case of a mistake in the wiseml syntax.
     */
    public abstract boolean apply(ExperimentState state) throws badSyntaxException;

}
