package visual;

import walker.utilities.Rendering;
import walker.Weyes;

import javax.swing.*;
import java.awt.event.*;

public class SpeedConfig extends JDialog {
    private JPanel contentPane;
    private JButton buttonOK;
    private JButton buttonCancel;
    private JTextField text;
    private JLabel label;

    public SpeedConfig() {
        setContentPane(contentPane);
        setTitle("Speed Configuration");
        getRootPane().setDefaultButton(buttonOK);
        setLocation(Rendering.getScreenHeight()/2, Rendering.getScreenHeight()/2);
        setAlwaysOnTop(true);
        text.setText(Weyes.crawler.getSpeed() + "");
        pack();
        setVisible(true);


        buttonOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onOK();
            }
        });

        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        });

        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                onCancel();
            }
        });

        contentPane.registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
    }

    private void onOK() {
        long s = Weyes.crawler.getSpeed();
        try {
            s = Long.parseLong(text.getText());

        } catch (Exception e){
            e.printStackTrace();
        }
        Weyes.crawler.setSpeed(s);
        dispose();
    }

    private void onCancel() {
        dispose();
    }
}
