package walker;

import com.thoughtworks.xstream.persistence.FilePersistenceStrategy;
import com.thoughtworks.xstream.persistence.PersistenceStrategy;
import com.thoughtworks.xstream.persistence.XmlArrayList;
import com.thoughtworks.xstream.persistence.XmlMap;
import com.thoughtworks.xstream.io.StreamException;
import experiment.ExperimentState;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Apr 19, 2010
 */
public class Persistor {


    // direct the file strategy to the ./tmp directory
    private static PersistenceStrategy strategy = new FilePersistenceStrategy(new File("/tmp/Weyes"));
    private static PersistenceStrategy errorStrategy = new FilePersistenceStrategy(new File("/tmp/Weyes/errors"));
    
    //    private static PersistenceStrategy strategy = new FilePersistenceStrategy(new File(tmp.getPath()));
    //    final static URL tmp = ClassLoader.getSystemResource("tmp");
    //    final static URL errors = ClassLoader.getSystemResource("tmp/errors");


    //    private static PersistenceStrategy errorStrategy = new FilePersistenceStrategy(new File(errors.getPath()));

    // create the map.
    private static XmlMap map = new XmlMap(strategy);

    // store all wiseml error positions in a list
    private static List errorLines = new ArrayList<String>();
    private static List list = new XmlArrayList(errorStrategy);

    /**
     * Persists an ExperimentState.
     *
     * @param state the ExperimentState to be stored.
     */
    public static void store(ExperimentState state){
        // todo: check  concurrency
        map.put(state.getTime(), state);
    }

    /**
     * Retrieves an ExperimentState from disk.
     *
     * @param timestamp the ExperimentState's timestamp is used as a key.
     * @return the retrieved ExperimentState.
     */
    public static ExperimentState retrieve(double timestamp){
        ExperimentState state = null;
        try{
            state = (ExperimentState)map.get(timestamp);
        } catch (StreamException e){
            new File("/tmp/Weyes/double@" + timestamp + ".xml").delete();
            System.out.println("Reseting due to bad Snapshot.");
            return null;
        }
        return state;
    }

    /**
     * When the user seeks to a position, the visualization must continue from the previous stored experiment State.
     * This method finds the timestamp of the previous method.
     *
     * @param timestamp where the user want's to seek (in milliseconds).
     * @return the actual seeking timestamp.
     */
    public static double getCloserTimestamp(double timestamp) {
        double distance = Double.MAX_VALUE;
        double previousTimestamp = -1;

        for (double time : (Set<Double>) map.keySet()){
            double newDistance = timestamp - time;
            if (timestamp > time && newDistance < distance){
                distance = newDistance;
                previousTimestamp = time;
            }
        }

        return previousTimestamp;
    }

    /**            
     * Temporarily stores a badSyntax error.
     *
     * @param line information about the position of the syntax error in the wiseml file.
     */
    public static void error(String line){
        errorLines.add(line);
    }

    /**
     * Persists all stored errors.
     */
    public static void persistErrors(){
        if (!errorLines.isEmpty()){
            list.add(errorLines);
            errorLines.clear();
        }
    }
}
