package walker.utilities;

import java.io.*;
import java.util.zip.GZIPInputStream;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Apr 10, 2010
 *
 * Provides utility methods that are file related.
 */
public class FileUtilities {

    public static long fileSize(String fileName){
        long fileSize = -1;

        if (fileName.endsWith(".gz")){
            RandomAccessFile raf = null;
            try {
                raf = new RandomAccessFile(fileName, "r");
                raf.seek(raf.length() - 4);
                int b4 = raf.read();
                int b3 = raf.read();
                int b2 = raf.read();
                int b1 = raf.read();
                fileSize = (b1 << 24) | (b2 << 16) + (b3 << 8) + b4;
                raf.close();
            }  catch (FileNotFoundException e) {
                e.printStackTrace();
            }catch (IOException e) {
                e.printStackTrace();
            }
        } else {
            fileSize = new File(fileName).length();
        }

        return fileSize;
    }

     /**
     * Counts the lines of a file.
     *
     * @param fileName the path of the file to be examined.
     * @return the number of lines.
     *
     * @throws java.io.IOException if there is no such file.
     */
    public static long countLines(String fileName) throws IOException {
        LineNumberReader reader = null;

        // if the input wiseml file is gzipped,
        if (fileName.endsWith("gz")){
            // Create a stream of the gziped wiseml file.
            try {
                reader = new LineNumberReader(new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream( fileName) ) ) ));

            } catch (FileNotFoundException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

        // If the input wiseml file isn't gzipped,
        } else {
            try {
                reader = new LineNumberReader(new FileReader(fileName));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        long cnt = 0;
        String lineRead = "";

        while ((lineRead = reader.readLine()) != null) {}

        cnt = reader.getLineNumber();
        reader.close();
        return cnt;
    }
}
