package walker.utilities;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Apr 18, 2010
 *
 * A utility class for supplying various methods that help with the
 * positioning of the gui objects in the screen.
 */
public class Rendering {

    private static Toolkit toolkit = Toolkit.getDefaultToolkit();

    /**
     * Get the current screen width.
     *
     * @return an integer containing the screen width.
     */
    public static int getScreenWidth(){
        return toolkit.getScreenSize().width;
    }

    /**
     * Get the current screen height.
     *
     * @return an integer containing the screen height.
     */
    public static int getScreenHeight(){
        return toolkit.getScreenSize().height;
    }

}
