package walker.utilities;

import org.xml.sax.SAXException;

import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Schema;
import javax.xml.XMLConstants;
import javax.xml.transform.stream.StreamSource;
import java.io.File;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: andy
 * Date: Mar 24, 2010
 *
 * Utility class that validates an xml file.
 */
public class Validator {

    /**
     * Attempts to validate a file against a given schema. It takes a really long time and shouldnt be used
     * on files bigger than a few hundred megabytes.
     *
     * @param xmlFile the xml file to validate
     * @param schemaFile the file that contains the schema with which the input file is going to be validated.
     * @return true if xml file validates
     */
    private boolean validate(String xmlFile, String schemaFile) {

        // Specifying the factory
        SchemaFactory factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);

        // Loading the wiseml schema.
        File schemaLocation = new File(schemaFile);

        // Compiling the schema.
        Schema schema = null;
        try {
            schema = factory.newSchema(schemaLocation);
        } catch (SAXException e) {
            e.printStackTrace();
        }

        try {
            if (schema != null) {
                schema.newValidator().validate(new StreamSource(xmlFile));
                return true;
            }
        } catch (SAXException e) {
            System.out.println(xmlFile + " is not valid because ");
            System.out.println(e.getMessage());
        } catch (IOException e) {
            e.printStackTrace();
        }

        return false;
    }
}
